PROGRAM ATOF_TEST(INPUT,OUTPUT);
USES(MATH);
CONST
    PC=10;
    AR=11;          {Accumulator = REGS[AR]}
    XR=12;          {X Register = REGS[XR]}
    YR=13;          {Y register = REGS[AY]}
    FOUT=$FE06;     {CONVERT FLOAT FAC TO STRING @ $0100}   
TYPE STRING = ARRAY [0..15] OF CHAR;  
TYPE FLOAT = ARRAY [0..2] OF INTEGER;
VAR I,PRSTRG,DIVF,IT2F,ADDF,SUBF,MULF,BPTR,FP,FP2,FPR,D1: INTEGER;
{T: INTEGER;}
N1: STRING;
BUFF: ARRAY [0..20] OF INTEGER;
CODE: ARRAY [0..8] OF INTEGER;
FDIV,FADD,FSUB,FMUL: ARRAY [0..18] OF INTEGER;
ITOF: ARRAY [0..26] OF INTEGER; 
MYFLT,FLT2,RES,D: FLOAT;

PROCEDURE INIT_FLOTS;
    BEGIN
        {M/L TO PRINT A STRING}
        READ(CODE[0],'160,689,1776,-11744,-14081,-2432,96');
        PRSTRG:=PTR(CODE[0]);   {STARTING ADDRESS OF ABOVE CODE}
        READ(FDIV[0],'160,1201,-15463,-20224,-26362,202,-16184');
        READ(FDIV[7],'-12282,8433,-473,160,-15431,-28416,-14328');
        READ(FDIV[14],'1728,-2352,96');{EXTRA ZERO NEEDED HERE, NOT SURE WHY}
        DIVF:=PTR(FDIV[0]); 
        READ(ITOF[0],'1445,-55,2032,1188,162,-32550,-24047');
        READ(ITOF[7],'-9727,-183,6216,1189,-183,361,26792');
        READ(ITOF[14],'105,800,-1282,1008,13088,-24322,-18176');
        READ(ITOF[21],'195,1681,-16184,-12282,24822');
        IT2F:=PTR(ITOF[0]); 
        READ(FADD[0],'160,1201,-15463,-20224,-26362,202,-16184');
        READ(FADD[7],'-12282,8433,-485,160,-15431,-28416,-14328');
        READ(FADD[14],'1728,-2352,96');
        ADDF:=PTR(FADD[0]);
        READ(FMUL[0],'160,1201,-15463,-20224,-26362,202,-16184');
        READ(FMUL[7],'-12282,8433,-479,160,-15431,-28416,-14328');
        READ(FMUL[14],'1728,-2352,96'); 
        MULF:=PTR(FMUL[0]);
        BPTR:=PTR(BUFF[0])*2;
        FP:=PTR(MYFLT[0])*2;
        FP2:=PTR(FLT2[0])*2;
        FPR:=PTR(RES[0])*2;     {RESULT} 
        D1:=PTR(D[0])*2;        {POINTER TO FLOAT USED IN ATOF}		
    END;

PROCEDURE POKE(ADDR,VAL: INTEGER);
    BEGIN
        REGS[PC]:=1;        
        REGS[0]:=ADDR;
        REGS[AR]:=VAL;
        MEM();
    END;    
    
FUNCTION PEEK(ADDR: INTEGER): INTEGER;
    BEGIN
        REGS[PC]:=0;        
        REGS[0]:=ADDR;
        MEM();
        PEEK:=REGS[AR];
    END;

{OUTPUT A STRING VARIABLE}
PROCEDURE PUTSTRING(VAR S2: STRING);
VAR Q,N: INTEGER;

    BEGIN
    Q:=1;
    N:=ORD(S2[0]);
    WHILE Q < N DO BEGIN
        WRITE(S2[Q]);
        Q:=Q+1;
    END;
END;

{READ A STRING OF CHARACTERS INTO A STRING VARIABLE}
PROCEDURE GETSTRING(VAR S1: STRING);    {LENGTH STORED IN 1ST ELEMENT}
VAR L: CHAR;
    J: INTEGER;
    BEGIN
        J:=1;
        L:=' ';
        WRITE(L);
        READ(L);
        WHILE ORD(L) <> 13 DO BEGIN
            WRITE(L);           
            IF ORD(L) <> 11 THEN BEGIN
                S1[J]:=L;
                J:=J+1;
            END;
            READ(L);
        END;        
        S1[0]:=CHR(J);
    END;

{COPY A PORTION OF ONE STRING VARIABLE TO ANOTHER, BEGINNING WITH ST TO ND}
PROCEDURE STRNG_COPY(VAR SOURCE,TARGET: STRING; ST,ND:INTEGER);
    VAR N,L,N2: INTEGER;
    BEGIN
        N:=1;
        L:=ND-ST+2;
        N2:=ST;
        WHILE N < L DO BEGIN
            TARGET[N]:=SOURCE[N2];
            N:=N+1;
            N2:=N2+1;
        END;
        TARGET[0]:=L;
    END;
            

{ASCII TO INTEGER - VALID RANGE IS -32768 TO 32767} 
FUNCTION ATOI(VAR NUM: STRING):INTEGER;
    VAR INT,S,E: INTEGER;
    NEG: BOOLEAN;
    BEGIN
        NEG:=FALSE;
        INT:=0;
        S:=1;
        E:=ORD(NUM[0]);
        IF ORD(NUM[1]) = '-' THEN BEGIN
            S:=2;
            NEG:=TRUE;
        END;
        WHILE S < E DO BEGIN
            INT:=INT*10;
            INT:=INT+ORD(NUM[S]) - 48;
            S:=S+1;
        END;
        IF NEG = TRUE THEN INT:=-INT;
        
        ATOI:=INT;
    END;
    
PROCEDURE INT2FLOAT(I,F:INTEGER);   {I IS INTEGER, F IS POINTER TO FLOAT}
    BEGIN
        REGS[1]:=I; {INTEGER}
        REGS[2]:=F; {POINTER TO FLOAT}
        SYS(IT2F);
    END;    
    
PROCEDURE PRNT_FLOAT;   
VAR PF: INTEGER;
    BEGIN
        REGS[0]:=$0100;
        SYS(PRSTRG);
    END;    
    
PROCEDURE FLOAT_ADD(R,D1,D2: INTEGER);
VAR X,N,I: INTEGER;
    BEGIN
        REGS[1]:=D2;
        REGS[2]:=D1;
        REGS[3]:=R;
        SYS(ADDF);
    END;    
    
PROCEDURE FLOAT_DIV(R,D1,D2: INTEGER);
VAR X,N,I: INTEGER;
    BEGIN
        REGS[1]:=D2;
        REGS[2]:=D1;
        REGS[3]:=R;
        SYS(DIVF);
    END;    
    
PROCEDURE FLOAT2STRG(F: INTEGER);   {F IS POINTER TO FLOAT}
VAR X,Y: INTEGER;
    BEGIN
        FOR X:=0 TO 5 DO BEGIN      {COPY FLOAT TO FAC}
            Y:=PEEK(F+X);
            POKE($00C3+X,Y);
        END;
        REGS[0]:=FOUT;              {CONVERT TO STRING}
        FLOP();     
    END;    

{ASCII TO FLOAT - VALID RANGE IS -32768.9999 TO 32767.9999} 
{ONLY 4 PLACES TO THE RIGHT OF THE DECIMAL ARE SUPPORTED!}
{NO BOUNDS CHECKS, EXCEED THE LIMITS, GET A WRONG ANSWER!}
{DEPENDANT ON GLOBAL VARIABLES FOR THE POINTERS TO FLOATS}
{AND BY IMPLICATION THE FLOATS THEMSELVES}
PROCEDURE ATOF(VAR NUM: STRING);
    VAR DECIMAL: BOOLEAN;
    LFT,RGT: STRING;
    N,E,L,R: INTEGER;
    BEGIN
        DECIMAL:=FALSE;         {ASSUME NO DECIMAL POINT}
        N:=1;                   {ACTUAL STRING STARTS AT 1}
        L:=0;
        E:=ORD(NUM[0]);         {LENGTH OF INPUT STRING}

		R:=0;
        
        INT2FLOAT(1,D1);        {SET D (D1) TO 1}
        INT2FLOAT(0,FPR);       {SET FPR TO 0}
        
        WHILE N < E DO BEGIN
            L:=L+1;
            N:=N+1;
            IF ORD(NUM[N]) = '.' THEN BEGIN
                DECIMAL:=TRUE;
                IF N <> E THEN R:=E-L;
                N:=E;
            END;
        END;
        
        STRNG_COPY(NUM,LFT,1,L);
        IF DECIMAL = TRUE THEN BEGIN
            STRNG_COPY(NUM,RGT,L+2,E-1);
            R:=ORD(RGT[0]);
            IF R = 5 THEN INT2FLOAT(10000,D1)
                ELSE IF R = 4 THEN INT2FLOAT(1000,D1)
                    ELSE IF R = 3 THEN INT2FLOAT(100,D1)
                        ELSE IF R = 2 THEN INT2FLOAT(10,D1)
                            ELSE INT2FLOAT(1,D1);
            R:=ATOI(RGT);   {CONVERT RGT TO INTEGER}
            
        END;
                    
        L:=ATOI(LFT);           {CONVERT LFT TO INTEGER}
        
        INT2FLOAT(L,FP);        {CONVERT L TO FLOAT}
        
        IF ORD(NUM[1]) = '-' THEN R:=-R;    {IF SO, MAKE NEGATIVE}
        INT2FLOAT(R,FP2);       			{CONVERT R TO FLOAT}
        
        IF DECIMAL = TRUE THEN FLOAT_DIV(FPR,FP2,D1); {SHIFT R BEHIND DECIMAL}

        FLOAT_ADD(FPR,FPR,FP);  {ADD THEM TO GET FINAL VALUE IN FPR}
    END;    

BEGIN
    INIT_FLOTS;
	I:=TRUE;
    WHILE I DO BEGIN
        WRITELN;
        WRITE('ENTER A DECIMAL NUMBER STRING TO COVERT, E TO EXIT');
        GETSTRING(N1);
		IF (ORD(N1[1]) = 'E') OR (ORD(N1[1]) = 'e') THEN I:=FALSE
		ELSE BEGIN
			WRITELN;
			ATOF(N1);
			WRITE('CONVERTED STRING ');
			PUTSTRING(N1);
			WRITE(' TO FLOAT ');
			FLOAT2STRG(FPR);
			PRNT_FLOAT;     
			WRITELN;
		END;
    END;
  END.  